/************************************************************************
 *
 * Basic Interval Arithmetic Subroutines Standard Functions
 * Modified for generalized intervals and Kaucher arithmetic (2005/06 A. Goldsztejn)
 * --------------------------------------------------------
 *
 * Copyright (c) 1993, 1997 Olaf Knueppel
 *
 * $Id: BiasKF.h,v 1.1.1.1 2004/04/21 10:02:36 dalmas Exp $
 *
 ************************************************************************/

#ifndef __BIASKF__
#define __BIASKF__

#include "BiasK0.h"

/************************************************************************
 *  Definition of Constants, Types, and Variables
 ************************************************************************/

extern REAL     BiasKPi;                 /* 3.141...                     */
extern REAL     BiasKTwoPi;
extern REAL     BiasKPiHalf;
extern REAL     BiasKPiQuarter;
extern REAL     BiasKE;
extern REAL     BiasKSqrt2;
extern REAL     BiasKInvSqrt2;           /* 1/ Sqrt(2)                   */
extern REAL     BiasKLn10;

/************************************************************************
 *  Function Prototypes
 ************************************************************************/

#if defined (__cplusplus)
extern "C" {
#endif

VOID    BiasKFuncInit    (VOID);

VOID    BiasKSin    (BIASKINTERVAL * const, const BIASKINTERVAL * const);
VOID    BiasKCos    (BIASKINTERVAL * const, const BIASKINTERVAL * const);
VOID    BiasKTan    (BIASKINTERVAL * const, const BIASKINTERVAL * const);
//VOID    BiasKCot    (BIASKINTERVAL * const, const BIASKINTERVAL * const);

VOID    BiasKArcSin (BIASKINTERVAL * const, const BIASKINTERVAL * const);
VOID    BiasKArcCos (BIASKINTERVAL * const, const BIASKINTERVAL * const);
VOID    BiasKArcTan (BIASKINTERVAL * const, const BIASKINTERVAL * const);
//VOID    BiasKArcCot (BIASKINTERVAL * const, const BIASKINTERVAL * const);

//VOID    BiasKSinh   (BIASKINTERVAL * const, const BIASKINTERVAL * const);
//VOID    BiasKCosh   (BIASKINTERVAL * const, const BIASKINTERVAL * const);
//VOID    BiasKTanh   (BIASKINTERVAL * const, const BIASKINTERVAL * const);
//VOID    BiasKCoth   (BIASKINTERVAL * const, const BIASKINTERVAL * const);

//VOID    BiasKArSinh (BIASKINTERVAL * const, const BIASKINTERVAL * const);
//VOID    BiasKArCosh (BIASKINTERVAL * const, const BIASKINTERVAL * const);
//VOID    BiasKArTanh (BIASKINTERVAL * const, const BIASKINTERVAL * const);
//VOID    BiasKArCoth (BIASKINTERVAL * const, const BIASKINTERVAL * const);

VOID    BiasKExp    (BIASKINTERVAL * const, const BIASKINTERVAL * const);
VOID    BiasKLog    (BIASKINTERVAL * const, const BIASKINTERVAL * const);
VOID    BiasKLog10  (BIASKINTERVAL * const, const BIASKINTERVAL * const);

VOID    BiasKIAbs   (BIASKINTERVAL * const, const BIASKINTERVAL * const);
VOID    BiasKSqr    (BIASKINTERVAL * const, const BIASKINTERVAL * const);
VOID    BiasKSqrt   (BIASKINTERVAL * const, const BIASKINTERVAL * const);
//VOID    BiasKRoot   (BIASKINTERVAL * const,
//                    const BIASKINTERVAL * const, const INT);

VOID    BiasKPowerN (BIASKINTERVAL * const,
                    const BIASKINTERVAL * const, const INT);
//VOID    BiasKPowerI (BIASKINTERVAL * const,
//                    const BIASKINTERVAL * const,
//                    const BIASKINTERVAL * const);

#if defined (__cplusplus)
}
#endif

#endif /* __BIASKF__ */
