/************************************************************************
 *
 * Basic Interval Arithmetic Subroutines Internal Definitions
 * ----------------------------------------------------------
 *
 * Copyright (c) 1993, 1994, 1997 Olaf Knueppel
 *
 * $Id: BiasKInt.h,v 1.1.1.1 2004/04/21 10:02:35 dalmas Exp $
 *
 ************************************************************************/

#ifndef __BIASKINTERN__
#define __BIASKINTERN__

/************************************************************************
 *  Macros
 ************************************************************************/

#if defined (__INTEGERCOMPARE__)
#if defined (__BIGENDIAN__)
#define SIGNIDX 0
#else
#define SIGNIDX (sizeof (REAL) / sizeof (unsigned long) - 1)
#endif
#define SIGNBIT (1L << (8 * sizeof (unsigned long) - 1))

#define Sign(r) \
        (((unsigned long *) & (r)) [SIGNIDX] & SIGNBIT)

#define Zero(r) \
        ((sizeof (REAL) == sizeof (unsigned long) ?              \
        (((unsigned long *) & (r)) [SIGNIDX] & ~ SIGNBIT) :      \
        (((unsigned long *) & (r)) [SIGNIDX] & ~ SIGNBIT) |      \
        ((unsigned long *) & (r)) [1 - SIGNIDX]) == 0)
#else /* __INTEGERCOMPARE__ */
#define Sign(r) ((r) < 0.0)
#define Zero(r) ((r) == 0.0)
#endif /* __INTEGERCOMPARE__ */

#if defined (__BIASKSETROUNDTONEAREST__)
#define _SetRoundToNearest()    _BiasKRoundNear ()
#else
#define _SetRoundToNearest()
#endif

#if !defined (__BIASKINLINEROUNDING__)
#define _BiasKRoundInit()        BiasKRoundInit ()
#define _BiasKRoundUp()          BiasKRoundUp ()
#define _BiasKRoundDown()        BiasKRoundDown ()
#define _BiasKRoundNear()        BiasKRoundNear ()
#endif

/************************************************************************
 *  Subroutines
 ************************************************************************/

VOID _BiasKError (const char * const s);

#endif /* __BIASKINTERN__ */
