/************************************************************************
 *
 * Basic Interval Arithmetic Subroutines Level 0
 * Modified for generalized intervals and Kaucher arithmetic (2005/06 A. Goldsztejn)
 * ---------------------------------------------
 *
 * Copyright (c) 1993, 1997 Olaf Knueppel
 *
 * Modifications for generalized intervals: Alexandre Goldsztejn (Alexandre@Goldsztejn.com)
 *
 ************************************************************************/

#ifndef __BIASKU__
#define __BIASKU__

#include "BiasKType.h"
#include "BiasK0.h"
#include "BiasK1.h"
#include "BiasK2.h"
#include "BiasKF.h"

#if defined (__cplusplus)
extern "C" {
#endif

void BiasKFormalSolveLinearEquation(
        const BIASKINTERVAL *A, const BIASKINTERVAL *X0, const BIASKINTERVAL *B,
        int dim, int N_iter_max, double epsilon, BIASKINTERVAL *X);

int BiasKLinearKrawczyk(
        const BIASKINTERVAL *A, const BIASKINTERVAL *X0, const BIASKINTERVAL *B,
        int dim, int N_iter_max, double epsilon, BIASKINTERVAL *X);

int BiasKLinearGaussSeidel_n(
        BIASKINTERVAL *A, BIASKINTERVAL *X, BIASKINTERVAL *B,
        int dim);

#if defined (__cplusplus)
}
#endif

#endif /* __BIASKU__ */
