/************************************************************************
 *
 * Basic Interval Arithmetic Subroutines 80x86-Rounding (Linux-ELF)
 * ----------------------------------------------------------------
 *
 * Copyright (c) 1997 Olaf Knueppel
 *
 * $Id: BiasRnd.h 56 2005-10-17 15:22:26Z keil $
 *
 ************************************************************************/

#ifndef __BIASRND__
#define __BIASRND__

#include "BiasKType.h"

#define _BiasRoundInit()
#define _BiasRoundUp()    asm volatile ("fldcw _BiasCwRoundUp")
#define _BiasRoundDown()  asm volatile ("fldcw _BiasCwRoundDown")
#define _BiasRoundNear()  asm volatile ("fldcw _BiasCwRoundNear")

#define __BIASINLINEROUNDING__

/*
 * If the following macro is defined,
 * division by zero aborts with an error message;
 * otherwise, bounds containing +/-oo
 * or NaN are computed.
 */
#define __BIASRAISEDIVIDEBYZERO__

/*
 * If the following macro is defined,
 * the rounding mode is set to nearest after
 * each interval operation.
 */
#undef  __BIASSETROUNDTONEAREST__

/*
 * The following macro defines the number of invalid bits
 * obtained by the standard C library functions (e.g. sin(), cos(), ...)
 */
#define __BIASSTDFUNCINVALIDBITS__      0

#endif /* __BIASRND__ */
