#include <iostream>
#include <fstream>
#include "calculator.h"

using namespace std;

extern FILE *yyin;
extern int yyparse();
extern int yywrap();
extern int yy_scan_string(const char *); /* especial */
extern bool putmark;

int main(int argc, char** argv) {

  if (argc > 1) yyin = fopen(argv[1],"r");
  if (yyin == NULL){
   cout<<"\n\n *----------------------------------------------------------";
   cout<<"----------*"<<endl<<endl;
   cout<<"                     Generalized Interval Calculator"<<endl;
   cout<<"                     -=-=-=-=-===-=-=-=-=-=-=-=-=-=-"<<endl<<endl;
   cout<<"  Implemented operations :  +, -, *, /, ^"<<endl;
   cout<<"  Classic functions      : sqr, sqrt, root, exp, log, abs, sin, cos,"
       <<"tan\n                 ,         arcsin, arccos, arctan"<<endl;
   cout<<"  Special functions      : Mid, Dual, Pro, Meet, Join"<<endl<<endl;
   cout<<"  Memory is implemented by assignment. (ex: x = [1,5];)"<<endl;
   cout<<endl;
   cout<<"  Ex: [0,1] - [2,4]; "<<endl;
   cout<<"      = [-4, -1]; "<<endl<<endl<<" *------------------------------";
   cout<<"---------------------------------------*"<<endl;
   cout<<endl<<"-> "<<flush;
   putmark = true;
  } else
    putmark = false;
  
  BiasKInit();
  BiasKFuncInit();
  yyparse();
  cout<<endl<<endl;
  return 0;
}
