%{
#include "calculator.h"
#include "grama.tab.h"

using namespace std;

%}
numero   [0-9]+
real     {numero}(\.{numero})?([e][+\-]{numero})?
variable [a-zA-Z]+{numero}*
%% 
"+"             {return(MAS);}
"-"             {return(MEN);}
"*"             {return(MUL);}
"/"             {return(DIV);}
"="             {return(ASIG);}
"("             {return(APAR);}
")"             {return(CPAR);}
"["             {return(ACOR);}
"]"             {return(CCOR);}
"^"             {return(ELEVA);}
";"             {return(PCOM);}
","             {return(COMA);}
"sqr"	        {yylval.id = new char[4];
                 strcpy(yylval.id, yytext); return (FUNC);}
"sqrt"	        {yylval.id = new char[5];
                 strcpy(yylval.id, yytext); return (FUNC);}
"root"	        {yylval.id = new char[5];
                 strcpy(yylval.id, yytext); return (FUNC);}
"cos"	        {yylval.id = new char[4];
                 strcpy(yylval.id, yytext); return (FUNC);}
"sin"	        {yylval.id = new char[4];
                 strcpy(yylval.id, yytext); return (FUNC);}
"exp"	        {yylval.id = new char[4];
                 strcpy(yylval.id, yytext); return (FUNC);}
"log"	        {yylval.id = new char[4];
                 strcpy(yylval.id, yytext); return (FUNC);}
"tan"	        {yylval.id = new char[4];
                 strcpy(yylval.id, yytext); return (FUNC);}
"arcsin"        {yylval.id = new char[7];
                 strcpy(yylval.id, yytext); return (FUNC);}
"arccos"        {yylval.id = new char[7];
                 strcpy(yylval.id, yytext); return (FUNC);}
"arctan"        {yylval.id = new char[7];
                 strcpy(yylval.id, yytext); return (FUNC);}
"abs"	        {yylval.id = new char[4];
                 strcpy(yylval.id, yytext); return (FUNC);}
"Dual"	        {yylval.id = new char[5];
                 strcpy(yylval.id, yytext); return (FUNC);}
"Pro"	        {yylval.id = new char[4];
                 strcpy(yylval.id, yytext); return (FUNC);}
"Mid"	        {yylval.id = new char[4];
                 strcpy(yylval.id, yytext); return (FUNC);}
"Meet"	        {return(MEET);}
"Join"	        {return(JOIN);}
"quit"          {return(QUIT);}
"exit"          {return(QUIT);}
"help"          {return(HELP);}
{variable}	{yylval.id = (char*)malloc(sizeof(char)*(strlen(yytext)+1));
                 strcpy(yylval.id, yytext); return (VAR);}
{real}  	{yylval.real = atof(yytext); return(NUM);}
[\n\t\v\f]      {/* NADA */;}
.               {/* NADA */;}
%%

int yywrap() { return 1;}

int yyerror(char *msg){
  cout<<msg<<endl;
  return 1; 
}
